summaryrefslogtreecommitdiffstats
path: root/bin
diff options
context:
space:
mode:
authorDaniel Baumann <daniel.baumann@progress-linux.org>2024-04-20 17:12:42 +0000
committerDaniel Baumann <daniel.baumann@progress-linux.org>2024-04-20 17:12:42 +0000
commitcbfc4abda5f50267b8b2a40de90ee57424381ec6 (patch)
tree5e335b17d0e8c9eaadeb403d5ea91822a5867933 /bin
parentInitial commit. (diff)
downloadopen-infrastructure-compute-tools-cbfc4abda5f50267b8b2a40de90ee57424381ec6.tar.xz
open-infrastructure-compute-tools-cbfc4abda5f50267b8b2a40de90ee57424381ec6.zip
Adding upstream version 20221223.upstream/20221223upstream
Signed-off-by: Daniel Baumann <daniel.baumann@progress-linux.org>
Diffstat (limited to 'bin')
-rwxr-xr-xbin/container117
-rwxr-xr-xbin/container-shell167
2 files changed, 284 insertions, 0 deletions
diff --git a/bin/container b/bin/container
new file mode 100755
index 0000000..fb52687
--- /dev/null
+++ b/bin/container
@@ -0,0 +1,117 @@
+#!/bin/sh
+
+# Copyright (C) 2014-2022 Daniel Baumann <daniel.baumann@open-infrastructure.net>
+#
+# SPDX-License-Identifier: GPL-3.0+
+#
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <https://www.gnu.org/licenses/>.
+
+set -e
+
+PROJECT="open-infrastructure"
+SOFTWARE="compute-tools"
+PROGRAM="container"
+
+HOOKS="/etc/${SOFTWARE}/hooks"
+
+# Parameter
+PARAMETER="${1}"
+
+if [ -z "${PARAMETER}" ]
+then
+ echo "Usage: ${PROGRAM} COMMAND [OPTIONS]" >&2
+ echo "Usage: ${PROGRAM} COMMAND1,COMMAND2,... [COMMON_OPTIONS]" >&2
+ echo
+ echo "See ${PROGRAM}(1) and ${PROJECT}(7) for more information."
+
+ exit 1
+fi
+
+# Command
+COMMANDS="${1}"
+
+# Options
+shift 1
+OPTIONS="${*}"
+
+for COMMAND in $(echo "${COMMANDS}" | sed -e 's|,| |g')
+do
+ if [ ! -e "/usr/libexec/${PROGRAM}/${COMMAND}" ]
+ then
+ echo "'${COMMAND}': no such ${PROGRAM} command, see ${PROGRAM}(1)." >&2
+ exit 1
+ fi
+
+ # Pre hooks
+ for FILE in "${HOOKS}/pre-${PROGRAM}".* "${HOOKS}/${NAME}.pre-${PROGRAM}"
+ do
+ if [ -x "${FILE}" ]
+ then
+ "${FILE}"
+ fi
+ done
+
+ # Notification
+ if echo "${OPTIONS}" | grep -qs "\--no-notification"
+ then
+ OPTIONS="$(echo "${OPTIONS}" | sed -e 's|--no-notification||')"
+ else
+ case "${COMMAND}" in
+ build|b|get|g|move|mv|remove|rm|rebuild|rb|restart|rs|start|s|stop|t|update|u)
+ if [ -z "${CONTAINER_USER}" ]
+ then
+ CONTAINER_USER="${SUDO_USER:-${USER}}"
+ fi
+
+ DATE="$(date +%Y-%m-%d\ %H:%M:%S)"
+ HOST="$(hostname -f 2> /dev/null || hostname)"
+
+ # logfile
+ echo "${DATE} ${HOST} ${CONTAINER_USER} ${PROGRAM} ${COMMAND} ${OPTIONS}" >> "/var/log/${SOFTWARE}/${PROGRAM}.log"
+
+ # irc
+ if [ -e /usr/bin/irk ]
+ then
+ for FILE in "/etc/${SOFTWARE}/${PROGRAM}.conf" "/etc/${SOFTWARE}/${PROGRAM}.conf.d"/*.conf
+ do
+ if [ -e "${FILE}" ]
+ then
+ . "${FILE}"
+ fi
+ done
+
+ if [ -n "${IRK_TARGETS}" ]
+ then
+ for TARGET in ${IRK_TARGETS}
+ do
+ irk "${TARGET}" "\x0300${CONTAINER_USER}\x03@\x0312${HOST}:\x03 \x0303${PROGRAM}\x03 \x0307${COMMAND}\x03 ${OPTIONS}"
+ done
+ fi
+ fi
+ ;;
+ esac
+ fi
+
+ # Run
+ "/usr/libexec/${PROGRAM}/${COMMAND}" "${OPTIONS}"
+
+ # Post hooks
+ for FILE in "${HOOKS}/post-${PROGRAM}".* "${HOOKS}/${NAME}.post-${PROGRAM}"
+ do
+ if [ -x "${FILE}" ]
+ then
+ "${FILE}"
+ fi
+ done
+done
diff --git a/bin/container-shell b/bin/container-shell
new file mode 100755
index 0000000..d63c3c0
--- /dev/null
+++ b/bin/container-shell
@@ -0,0 +1,167 @@
+#!/bin/sh
+
+# Copyright (C) 2014-2022 Daniel Baumann <daniel.baumann@open-infrastructure.net>
+#
+# SPDX-License-Identifier: GPL-3.0+
+#
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <https://www.gnu.org/licenses/>.
+
+set -e
+
+PROJECT="open-infrastructure"
+SOFTWARE="compute-tools"
+PROGRAM="container"
+
+COMMAND="$(basename ${0})"
+
+LC_ALL="C.UTF-8"
+
+Usage ()
+{
+ echo "Usage: ${PROGRAM}-shell" >&2
+ exit 1
+}
+
+Shell ()
+{
+ COMMAND="${1}"
+
+ if [ -z "${COMMAND}" ]
+ then
+ return
+ fi
+
+ shift 1
+
+ OPTIONS="${@}"
+
+ case "${COMMAND}" in
+ about)
+ man ${PROGRAM} || true
+
+ return
+ ;;
+
+ logout|exit)
+ exit 0
+ ;;
+
+ help)
+ case "${OPTIONS}" in
+ "")
+ echo
+ echo "The following ${PROGRAM} commands are available:"
+ echo
+
+ cd "/usr/libexec/${PROGRAM}"
+ find . -type f -printf " %f\n" | sort
+ cd "${OLDPWD}"
+
+ if [ -n "${CONTAINER_COMMANDS_ENABLE}" ]
+ then
+ echo
+ echo "The following container commands are enabled for the current user:"
+ echo " ${CONTAINER_COMMANDS_ENABLE}"
+ fi
+
+ if [ -n "${CONTAINER_COMMANDS_DISABLE}" ]
+ then
+ echo
+ echo "The following container commands are disabled for the current user:"
+ echo " ${CONTAINER_COMMANDS_DISABLE}"
+ fi
+
+ echo
+ echo "Use 'help COMMAND' for more information."
+
+ return
+ ;;
+
+ *)
+ man ${PROGRAM}-${1} || true
+
+ return
+ ;;
+ esac
+ ;;
+ esac
+
+ if [ ! -e "/usr/libexec/${PROGRAM}/${COMMAND}" ]
+ then
+ echo "'${COMMAND}': no such ${PROGRAM} command" >&2
+ return
+ fi
+
+ if [ -n "${CONTAINER_COMMANDS_ENABLE}" ]
+ then
+ COMMAND_ALLOWED=""
+
+ for CONTAINER_COMMAND in ${CONTAINER_COMMANDS_ENABLE}
+ do
+ case "${CONTAINER_COMMAND}" in
+ ${COMMAND}|all|about|logout|exit|help)
+ COMMAND_ALLOWED="true"
+ ;;
+ esac
+ done
+
+ case "${COMMAND_ALLOWED}" in
+ true)
+ ;;
+
+ *)
+ echo "'${COMMAND}': command not allowed for current user" >&2
+ return
+ ;;
+ esac
+ fi
+
+ if [ -n "${CONTAINER_COMMANDS_DISABLE}" ]
+ then
+ COMMAND_DISALLOWED=""
+
+ for CONTAINER_COMMAND in ${CONTAINER_COMMANDS_DISABLE}
+ do
+ case "${CONTAINER_COMMAND}" in
+ ${COMMAND}|all|about|logout|exit|help)
+ COMMAND_DISALLOWED="true"
+ ;;
+ esac
+ done
+
+ case "${COMMAND_DISALLOWED}" in
+ true)
+ echo "'${COMMAND}': command not allowed for current user" >&2
+ return
+ ;;
+ esac
+ fi
+
+ echo
+ sudo ${PROGRAM} ${COMMAND} ${OPTIONS} || true
+}
+
+trap 'echo' EXIT HUP INT QUIT TERM
+
+echo "${SOFTWARE} $(${PROGRAM} version)"
+echo "Type \"about\" or \"help\" for more information, \"logout\" to exit."
+
+while true
+do
+ echo
+ echo -n "${PROGRAM}: "
+ read CMDLINE
+
+ Shell ${CMDLINE}
+done